@echo off
rem // decipha 2022-02-09
echo.
echo Current Folder: 
echo %cd%
echo.
@if exist "%1" goto CONTINUED
@if not exist "%1" goto ERROR
set orig=%cd%

:CONTINUED
echo.
echo // Specified path has been found! //
echo.
@if not "%cd%" == "D:\TUNING\xvi32" goto REMOTE_LOCATION


rem // need to copy source to xvi32 folder
@if exist "D:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 D:\TUNING\xvi32\temp.bin
d:
cd D:\TUNING\xvi32
goto CONTINUED



:REMOTE_LOCATION
echo REMOTE LOCATION
rem // need to copy source to xvi32 folder
@if exist "C:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 C:\TUNING\xvi32\temp.bin
C:
cd C:\TUNING\xvi32

:CONTINUED
rem // verify if free and clear to use temp file names
@if exist "0.bin" goto DUPLICATE
@if exist "1.bin" goto DUPLICATE
rem // verify operations files are not missing
rem // only list which files are missing
@if not exist "decipha\trans.bin" echo !!! Missing critical operation file from decipha folder: trans.bin !!!
@if not exist "decipha\MMC\del_20k_at_0.xsc" echo !!! Missing critical operation file: del_20k_at_0.xsc !!!
rem // jump cuz files are missing now
@if not exist "decipha\trans.bin" goto MISSING
@if not exist "decipha\MMC\del_20k_at_0.xsc" goto MISSING

echo.
echo.
echo Input File: %~n1
echo.
echo Combine 4mb tune and trans files to 7904kb for 17-19 6.7 diesel.
echo.

rem // first make duplicate files to be able to split each bank
copy /b /v /n /y "temp.bin" "0.bin"
copy /b /v /n /y "decipha\trans.bin" "1.bin"

rem // Split Banks
xvi32.exe 0.bin /S=decipha\MMC\del_20k_at_0.xsc
xvi32.exe 1.bin /S=decipha\MMC\del_20k_at_0.xsc


rem // Recompile to 7904k
copy /b /v /n /y "0.bin" + "1.bin" "%~n1_diesel_file.bin"
echo.
echo New File Name: %~n1_diesel_file.bin
echo.
echo Original Folder: %orig%
echo.
move /y "%~n1_diesel_file.bin" "decipha"


:CLEANUP
rem // put pause here if need to check files for debugging
@if exist "0.bin" del 0.bin
@if exist "1.bin" del 1.bin
@if exist "temp.bin" del temp.bin
echo.
echo Operations Completed Successfully.
goto END

:ERROR
echo.
echo ERROR! No File Selected.
echo.
pause
goto END

:DUPLICATE
echo.
echo !!! Duplicate temporary files already exist !!!


:MISSING
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
pause

:END
echo.
echo End of Execution.
echo.
exit