@echo off
rem // decipha 2022-02-09
echo.
echo Current Folder: 
echo %cd%
echo.
@if exist "%1" goto CONTINUED
@if not exist "%1" goto ERROR
set orig=%cd%

:CONTINUED
echo.
echo // Specified path has been found! //
echo.
@if not "%cd%" == "D:\TUNING\xvi32" goto REMOTE_LOCATION


rem // need to copy source to xvi32 folder
@if exist "D:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 D:\TUNING\xvi32\temp.bin
d:
cd D:\TUNING\xvi32
goto CONTINUED


:REMOTE_LOCATION
echo REMOTE LOCATION
rem // need to copy source to xvi32 folder
@if exist "C:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 C:\TUNING\xvi32\temp.bin
C:
cd C:\TUNING\xvi32


:CONTINUED
rem // verify if free and clear to use temp file names
@if exist "0.bin" goto DUPLICATE
@if exist "1.bin" goto DUPLICATE
rem // verify operations files are not missing
rem // only list which files are missing
@if not exist "decipha\MMC\20000_0.bin" echo !!! Missing blank (0s) 0x20,000 file for recompiling !!!
@if not exist "decipha\MMC\Split_4mb_diesel_tune.xsc" echo !!! Missing critical operation file: Split_4mb_diesel_tune.xsc !!!
@if not exist "decipha\MMC\Split_4mb_diesel_trans.xsc" echo !!! Missing critical operation file: Split_4mb_diesel_trans.xsc !!!
rem // jump cuz files are missing now
@if not exist "decipha\MMC\20000_0.bin" goto MISSING
@if not exist "decipha\MMC\Split_4mb_diesel_tune.xsc" goto MISSING
@if not exist "decipha\MMC\Split_4mb_diesel_trans.xsc" goto MISSING

echo.
echo.
echo Input File: %~n1
echo.
echo Split 7904kb 17-19 6.7 diesel and trans file to 4mb tune and trans files for PCMflash.
echo.

rem // first make duplicate files to be able to split each bank
copy /b /v /n /y "temp.bin" "0.bin"
copy /b /v /n /y "temp.bin" "1.bin"


rem // Split Banks
xvi32.exe 0.bin /S=decipha\MMC\Split_4mb_diesel_tune.xsc
xvi32.exe 1.bin /S=decipha\MMC\Split_4mb_diesel_trans.xsc


rem // Recompile to 4mb 
copy /b /v /n /y "decipha\MMC\20000_0.bin" + "0.bin" "%~n1_4mb_diesel_tune.bin"
copy /b /v /n /y "decipha\MMC\20000_0.bin" + "1.bin" "%~n1_4mb_diesel_trans.bin"
echo.
echo New File Name: %~n1_4mb_diesel_tune.bin
echo New File Name: %~n1_4mb_diesel_trans.bin
echo.
echo Original Folder: %orig%
echo.
move /y "%~n1_4mb_diesel_tune.bin" "decipha"
move /y "%~n1_4mb_diesel_trans.bin" "decipha"


:CLEANUP
rem // put pause here if need to check files for debugging
@if exist "0.bin" del 0.bin
@if exist "1.bin" del 1.bin
@if exist "temp.bin" del temp.bin
echo.
echo Operations Completed Successfully.
goto END

:ERROR
echo.
echo ERROR! No File Selected.
echo.
pause
goto END

:DUPLICATE
echo.
echo !!! Duplicate temporary files already exist !!!


:MISSING
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
pause

:END
echo.
echo End of Execution.
echo.
exit