@echo off
rem // decipha 2020-11-30
@if not exist %1 goto ERROR
set orig=%cd%

@if not "%cd%" == "D:\TUNING\xvi32" goto REMOTE_LOCATION


rem // need to copy source to xvi32 folder
@if exist "D:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 D:\TUNING\xvi32\temp.bin
d:
cd D:\TUNING\xvi32
goto CONTINUED


:REMOTE_LOCATION
echo REMOTE LOCATION
rem // need to copy source to xvi32 folder
@if exist "C:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 C:\TUNING\xvi32\temp.bin
C:
cd C:\TUNING\xvi32


:CONTINUED
rem // verify if free and clear to use temp file names
@if exist "8.bin" goto DUPLICATE
rem // verify operations files are not missing
@if not exist "decipha\EEC\2000.bin" goto MISSING
@if not exist "decipha\PPC\10000.bin" goto MISSING
@if not exist "decipha\EEC\112k_Split_1.xsc" goto OPSMISSING
@if not exist "decipha\EEC\112k_Split_8.xsc" goto OPSMISSING

echo.
echo.
echo Input File: %~n1
echo.
echo Convert 112k [1-8] to 256k [X-1-8-X]
echo.


copy "temp.bin" "8.bin"

rem // Split Banks
xvi32.exe temp.bin /S=decipha\EEC\112k_Split_1.xsc
xvi32.exe 8.bin /S=decipha\EEC\112k_Split_8.xsc



rem // Recompile to 256k [X-1-8-X]
copy /b /v /n /y "decipha\PPC\10000.bin" + "decipha\EEC\2000.bin" + "temp.bin" + "decipha\EEC\2000.bin" + "8.bin" + "decipha\PPC\10000.bin" "%~n1_256k.bin"
echo.
echo New File Name: %~n1_256k.bin
echo.
echo Original Folder: %orig%
echo.
move /y "%~n1_256k.bin" "decipha"


:CLEANUP
rem // put pause here if need to check files for debugging
@if exist "temp.bin" del temp.bin
@if exist "8.bin" del 8.bin
echo.
echo Operations Completed Successfully.
goto END

:ERROR
echo.
echo ERROR! No File Selected.
echo.
pause
goto END

:DUPLICATE
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
echo !!! Duplicate temporary files already exist !!!
pause
goto END

:MISSING
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
echo !!! Missing 0x2000 or 0x10000 null filler (0xFF) file for recompiling !!!
pause
goto END

:OPSMISSING
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
echo !!! Missing critical operations files !!!
pause

:END
echo.
echo End of Execution.
echo.
exit