@echo off
rem // decipha 2021-01-27
@if not exist %1 goto ERROR
set orig=%cd%

@if not "%cd%" == "D:\TUNING\xvi32" goto REMOTE_LOCATION


rem // need to copy source to xvi32 folder
@if exist "D:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 D:\TUNING\xvi32\temp.bin
d:
cd D:\TUNING\xvi32
goto CONTINUED


:REMOTE_LOCATION
echo REMOTE LOCATION
rem // need to copy source to xvi32 folder
@if exist "C:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 C:\TUNING\xvi32\temp.bin
C:
cd C:\TUNING\xvi32


:CONTINUED
rem // verify if free and clear to use temp file names
@if exist "0.bin" goto DUPLICATE
@if exist "1.bin" goto DUPLICATE
@if exist "9.bin" goto DUPLICATE
@if exist "8.bin" goto DUPLICATE
rem // verify operations files are not missing
@if not exist "decipha\EEC\2000.bin" goto MISSING
@if not exist "decipha\EEC\SplitBankA.xsc" goto OPSMISSING
@if not exist "decipha\EEC\SplitBankB.xsc" goto OPSMISSING
@if not exist "decipha\EEC\SplitBankC.xsc" goto OPSMISSING
@if not exist "decipha\EEC\SplitBankD.xsc" goto OPSMISSING

echo.
echo.
echo Input File: %~n1
echo.
echo Convert 216k [0-1-9-8] to 224k [8-1-0-9]
echo.

copy /b /v /n /y "temp.bin" + "decipha\EEC\2000.bin" "0.bin"
copy /b /v /n /y "temp.bin" + "decipha\EEC\2000.bin" "1.bin"
copy /b /v /n /y "decipha\EEC\2000.bin" + "temp.bin" "9.bin"
copy /b /v /n /y "decipha\EEC\2000.bin" + "temp.bin" "8.bin"

rem // Split Banks
xvi32.exe 0.bin /S=decipha\EEC\SplitBankA.xsc
xvi32.exe 1.bin /S=decipha\EEC\SplitBankB.xsc
xvi32.exe 9.bin /S=decipha\EEC\SplitBankC.xsc
xvi32.exe 8.bin /S=decipha\EEC\SplitBankD.xsc

rem // always del ram rom to make FF filler regardless
xvi32.exe 1.bin /S=decipha\EEC\DelRamRomBnk01.xsc

rem // Recompile to 224k [8-1-0-9]
copy /b /v /n /y  "8.bin" + "1.bin" + "decipha\EEC\2000.bin"  + "0.bin" + "9.bin" "%~n1_224k.bin"
echo.
echo New File Name: %~n1_224k.bin
echo.
echo Original Folder: %orig%
echo.
move /y "%~n1_224k.bin" "decipha"


:CLEANUP
rem // put pause here if need to check files for debugging
@if exist "0.bin" del 0.bin
@if exist "1.bin" del 1.bin
@if exist "9.bin" del 9.bin
@if exist "8.bin" del 8.bin
@if exist "temp.bin" del temp.bin
echo.
echo Operations Completed Successfully.
goto END

:ERROR
echo.
echo ERROR! No File Selected.
echo.
pause
goto END

:DUPLICATE
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
echo !!! Duplicate temporary files already exist !!!
pause
goto END

:MISSING
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
echo !!! Missing 0x2000 null filler (0xFF) file for recompiling !!!
pause
goto END

:OPSMISSING
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
echo !!! Missing critical operations files !!!
pause

:END
echo.
echo End of Execution.
echo.
exit