@echo off
rem // decipha 2021-01-28, determines order of 224k files
@if not exist %1 goto ERROR
set orig=%cd%

@if not "%cd%" == "D:\TUNING\xvi32" goto REMOTE_LOCATION

rem // need to copy source to xvi32 folder
@if exist "D:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 D:\TUNING\xvi32\temp.bin
d:
cd D:\TUNING\xvi32
goto CONTINUED


:REMOTE_LOCATION
echo REMOTE LOCATION
rem // need to copy source to xvi32 folder
@if exist "C:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 C:\TUNING\xvi32\temp.bin
C:
cd C:\TUNING\xvi32


:CONTINUED
echo.
echo.
echo Input File: %~n1
echo.
echo Convert 224k [1-8-0-9 or 0-1-9-8 or 8-1-0-9] to 216k [0-1-9-8]
echo.


rem // verify operations files are not missing
@if not exist "decipha\EEC\SplitBankA.xsc" goto OPSMISSING
@if not exist "decipha\EEC\SplitBankB.xsc" goto OPSMISSING
@if not exist "decipha\EEC\SplitBankC.xsc" goto OPSMISSING
@if not exist "decipha\EEC\SplitBankD.xsc" goto OPSMISSING
@if not exist "decipha\EEC\DelRamRomBnk01.xsc" goto OPSMISSING

:RETRY
rem // verify if free and clear to use temp file names
@if exist "2bytes.vbs" goto DUPLICATE 
@if exist "0.bin" goto DUPLICATE
@if exist "1.bin" goto DUPLICATE
@if exist "9.bin" goto DUPLICATE
@if exist "8.bin" goto DUPLICATE

copy temp.bin 0.bin
copy temp.bin 1.bin
copy temp.bin 8.bin
copy temp.bin 9.bin


//determine which order
echo Const adTypeBinary = 1 > 2bytes.vbs
echo filename = "%~1" >> 2bytes.vbs
echo Set BinaryStream = CreateObject("ADODB.Stream") >> 2bytes.vbs
echo BinaryStream.Type = adTypeBinary >> 2bytes.vbs
echo BinaryStream.Open >> 2bytes.vbs
echo BinaryStream.LoadFromFile FileName >> 2bytes.vbs
echo buf = BinaryStream.Read >> 2bytes.vbs
echo BinaryStream.Close >> 2bytes.vbs
REM Decimal or...
rem echo wscript.echo ASCB(MIDB(buf,1,1)) ^& "," ^& ASCB(MIDB(buf,2,1)) >> 2bytes.vbs
REM Hex
echo wscript.echo Hex(ASCB(MIDB(buf,1,1))) ^& "," ^& Hex(ASCB(MIDB(buf,3,1))) >> 2bytes.vbs
for /f "tokens=1,2 delims=," %%A in ('cscript //nologo 2bytes.vbs') do (
   set byte1=%%A
   set byte2=%%B
   )
echo Byte 1 is %byte1%
echo Byte 2 is %byte2%


rem // usually true if 1-8-0-9
if %byte1% == 27 goto BIN1809X


rem // usually true if 8-1-0-9
rem // this is actually byte 3
if %byte2% == E7 goto BIN8109X

if not %byte1% == FF goto STOPERROR


goto DANADA

:BIN1809X
if not %byte2% == C goto STOPERROR
echo.
echo 224k [1-8-0-9] Identified!
echo.
rem // Split Banks 1-8-0-9
xvi32.exe 1.bin /S=decipha\EEC\SplitBankA.xsc
xvi32.exe 8.bin /S=decipha\EEC\SplitBankB.xsc
xvi32.exe 0.bin /S=decipha\EEC\SplitBankC.xsc
xvi32.exe 9.bin /S=decipha\EEC\SplitBankD.xsc
goto OHHYEAH

:BIN8109X
echo.
echo 224k [8-1-0-9] Identified! (Database Read)
echo.
rem // split Banks 8-1-0-9
xvi32.exe 8.bin /S=decipha\EEC\SplitBankA.xsc
xvi32.exe 1.bin /S=decipha\EEC\SplitBankB.xsc
xvi32.exe 0.bin /S=decipha\EEC\SplitBankC.xsc
xvi32.exe 9.bin /S=decipha\EEC\SplitBankD.xsc
goto OHHYEAH

:DANADA
if not %byte2% == 27 goto STOPERROR
@if not exist "decipha\EEC\Del2kAt1A000.xsc" goto OPSMISSING
echo.
echo 224k [0-1-9-8] Identified!
echo.
xvi32.exe temp.bin /S=decipha\EEC\Del2kAt1A000.xsc
rem // Recompile to 216k [0-1-9-8]
echo.
echo renaming file
ren temp.bin "%~n1_216k.bin"
GOTO DADADUNN

:OHHYEAH
rem // always del ram rom to make FF filler regardless
xvi32.exe 1.bin /S=decipha\EEC\DelRamRomBnk01.xsc

rem // Recompile to 216k [0-1-9-8]
copy /b /v /n /y "0.bin" + "1.bin" + "9.bin" + "8.bin" "%~n1_216k.bin"

:DADADUNN
echo.
echo New File Name: %~n1_216k.bin
echo.
echo Original Folder: %orig%
echo.
echo. moving file
move /y "%~n1_216k.bin" "decipha"


:CLEANUP
rem // put pause here if need to check files for debugging
@if exist "0.bin" del 0.bin
@if exist "1.bin" del 1.bin
@if exist "9.bin" del 9.bin
@if exist "8.bin" del 8.bin
@if exist "temp.bin" del temp.bin
@if exist "2bytes.vbs" del 2bytes.vbs
echo.
echo Operations Completed Successfully.
goto END

:STOPERROR
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
echo !!! Bank Order CANNOT be determined !!!
pause
goto END

:ERROR
echo.
echo ERROR! No File Selected.
echo.
pause
goto END

:DUPLICATE
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
echo !!! Duplicate temporary files already exist !!!
echo.
echo Exit this application if you do not wish to delete these files!
echo.
echo Otherwise, files will be deleted!
echo.
pause
@if exist "0.bin" del 0.bin
@if exist "1.bin" del 1.bin
@if exist "9.bin" del 9.bin
@if exist "8.bin" del 8.bin
@if exist "temp.bin" del temp.bin
@if exist "2bytes.vbs" del 2bytes.vbs
goto RETRY

:MISSING
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
echo !!! Missing 0x2000 null filler (0xFF) file for recompiling !!!
pause
goto END

:OPSMISSING
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
echo !!! Missing critical operations files !!!
pause

:END
echo.
echo End of Execution.
echo.
exit