@echo off
rem // decipha 2022-09-25 converted 2024-02-22
echo.
echo Current Folder: 
echo %cd%
echo.
@if exist "%1" goto CONTINUED
@if not exist "%1" goto ERROR
set orig=%cd%

:CONTINUED
echo.
echo // Specified path has been found! //
echo.
@if not "%cd%" == "D:\TUNING\xvi32" goto REMOTE_LOCATION


rem // need to copy source to xvi32 folder
@if exist "D:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 D:\TUNING\xvi32\temp.bin
d:
cd D:\TUNING\xvi32
goto CONTINUED



:REMOTE_LOCATION
echo REMOTE LOCATION
rem // need to copy source to xvi32 folder
@if exist "C:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 C:\TUNING\xvi32\temp.bin
C:
cd C:\TUNING\xvi32

:CONTINUED
rem // verify if free and clear to use temp file names
@if exist "0.bin" goto DUPLICATE
@if exist "1.bin" goto DUPLICATE
@if exist "2.bin" goto DUPLICATE
@if exist "3.bin" goto DUPLICATE
@if exist "9.bin" goto DUPLICATE
rem // verify operations files are not missing
rem // only list which files are missing
@if not exist "decipha\PCMF\10f150_delecu_parta.xsc" echo !!! Missing critical operation file from decipha PCMF folder: 10f150_delecu_parta.xsc !!!
@if not exist "decipha\PCMF\10f150_delecu_partb.xsc" echo !!! Missing critical operation file from decipha PCMF folder: 10f150_delecu_partb.xsc !!!
@if not exist "decipha\PCMF\10f150_delecu_partc.xsc" echo !!! Missing critical operation file from decipha PCMF folder: 10f150_delecu_partc.xsc !!!
@if not exist "decipha\PCMF\10f150_deltrans.xsc" echo !!! Missing critical operation file from decipha PCMF folder: 10f150_deltrans.xsc !!!
rem // jump cuz files are missing now
@if not exist "decipha\PCMF\10f150_delecu_parta.xsc" goto MISSING
@if not exist "decipha\PCMF\10f150_delecu_partb.xsc" goto MISSING
@if not exist "decipha\PCMF\10f150_delecu_partc.xsc" goto MISSING
@if not exist "decipha\PCMF\10f150_deltrans.xsc" goto MISSING


echo.
echo.
echo Input File: %~n1
echo.
echo Split tune and trans files from 3200kb for 2560kb tune and trans file for 2010 f150 bosch ecu.
echo.

rem // make larger file
copy /b /v /n /y "decipha\PPC\10000.bin" + "temp.bin" "0.bin"

rem // second make duplicate files
copy /b /v /n /y "0.bin" "2.bin"
copy /b /v /n /y "0.bin" "1.bin"

rem // then delete ecu from trans file and delete trans from ecu file

xvi32.exe 0.bin /S=decipha\PCMF\10f150_deltrans.xsc
xvi32.exe 1.bin /S=decipha\PCMF\10f150_delecu_parta.xsc
copy /b /v /n /y "1.bin" "3.bin"
xvi32.exe 3.bin /S=decipha\PCMF\10f150_delecu_partc.xsc
xvi32.exe 2.bin /S=decipha\PCMF\10f150_delecu_partb.xsc


rem // combine to ecu segment
copy /b /v /n /y "3.bin" + "1.bin" + "2.bin" "%~n1_ecu_segment.bin"

rem // rename to appropriate trans file
copy /b /v /n /y "0.bin" "%~n1_trans_segment.bin"
echo.
echo New File Name: %~n1_trans_segment.bin
echo New File Name: %~n1_ecu_segment.bin
echo.
echo Original Folder: %orig%
echo.
move /y "%~n1_ecu_segment.bin" "decipha"
move /y "%~n1_trans_segment.bin" "decipha"
echo REMEMBER TO CHANGE FILE NAME TO trans.bin if you would like to recompile with this transmission tune.
echo.
pause


:CLEANUP
rem // put pause here if need to check files for debugging
@if exist "0.bin" del 0.bin
@if exist "1.bin" del 1.bin
@if exist "2.bin" del 2.bin
@if exist "3.bin" del 3.bin
@if exist "9.bin" del 9.bin
@if exist "temp.bin" del temp.bin
echo.
echo Operations Completed Successfully.
goto END

:ERROR
echo.
echo ERROR! No File Selected.
echo.
pause
goto END

:DUPLICATE
echo.
echo !!! Duplicate temporary files already exist !!!


:MISSING
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
pause

:END
echo.
echo End of Execution.
echo.
exit