@echo off
rem // decipha 2022-09-25
echo.
echo Current Folder: 
echo %cd%
echo.
@if exist "%1" goto CONTINUED
@if not exist "%1" goto ERROR
set orig=%cd%

:CONTINUED
echo.
echo // Specified path has been found! //
echo.
@if not "%cd%" == "D:\TUNING\xvi32" goto REMOTE_LOCATION


rem // need to copy source to xvi32 folder
@if exist "D:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 D:\TUNING\xvi32\temp.bin
d:
cd D:\TUNING\xvi32
goto CONTINUED



:REMOTE_LOCATION
echo REMOTE LOCATION
rem // need to copy source to xvi32 folder
@if exist "C:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 C:\TUNING\xvi32\temp.bin
C:
cd C:\TUNING\xvi32

:CONTINUED
rem // verify if free and clear to use temp file names
@if exist "0.bin" goto DUPLICATE
@if exist "1.bin" goto DUPLICATE
@if exist "2.bin" goto DUPLICATE
@if exist "9.bin" goto DUPLICATE
rem // verify operations files are not missing
rem // only list which files are missing
@if not exist "decipha\PCMF\12diesel67_striptrans.xsc" echo !!! Missing critical operation file from decipha PCMF folder: 12diesel67_striptrans.xsc !!!
@if not exist "decipha\PCMF\12diesel67_deltrans.xsc" echo !!! Missing critical operation file from decipha PCMF folder: 12diesel67_deltrans.xsc !!!
@if not exist "decipha\PCMF\12diesel67_parta.xsc" echo !!! Missing critical operation file from decipha PCMF folder: 12diesel67_parta.xsc !!!
@if not exist "decipha\PCMF\12diesel67_partb.xsc" echo !!! Missing critical operation file from decipha PCMF folder: 12diesel67_partb.xsc !!!
@if not exist "decipha\PCMF\12diesel67_partc.xsc" echo !!! Missing critical operation file from decipha PCMF folder: 12diesel67_partc.xsc !!!
rem // jump cuz files are missing now
@if not exist "decipha\PCMF\12diesel67_striptrans.xsc" goto MISSING
@if not exist "decipha\PCMF\12diesel67_deltrans.xsc" goto MISSING
@if not exist "decipha\PCMF\12diesel67_parta.xsc" goto MISSING
@if not exist "decipha\PCMF\12diesel67_partb.xsc" goto MISSING
@if not exist "decipha\PCMF\12diesel67_partc.xsc" goto MISSING


echo.
echo.
echo Input File: %~n1
echo.
echo Split tune and trans files from 4319kb for 4096k tune and trans file for 12-16 ?? 6.7 diesel.
echo.

rem // first make duplicate file for trans
copy /b /v /n /y "temp.bin" "9.bin"

rem// first need to delete trans from just tune file before splitting so don't need to double work
xvi32.exe temp.bin /S=decipha\PCMF\12Diesel67_deltrans.xsc
copy /b /v /n /y "temp.bin" "0.bin"
copy /b /v /n /y "temp.bin" "1.bin"
copy /b /v /n /y "temp.bin" "2.bin"


rem // Split Banks
xvi32.exe 0.bin /S=decipha\PCMF\12Diesel67_parta.xsc
xvi32.exe 1.bin /S=decipha\PCMF\12Diesel67_partb.xsc
xvi32.exe 2.bin /S=decipha\PCMF\12Diesel67_partc.xsc

xvi32.exe 9.bin /S=decipha\PCMF\12Diesel67_striptrans.xsc




rem // Recompiling Tune only to 4096k but trans file already split
copy /b /v /n /y "0.bin" + "decipha\PCMF\10000.bin" + "1.bin" + "decipha\PCMF\20000.bin" + "2.bin" "%~n1_diesel_file_4096k.bin"
copy /b /v /n /y "9.bin" "%~n1_diesel_file_trans.bin"
echo.
echo New File Name: %~n1_diesel_file_4096k.bin
echo New File Name: %~n1_diesel_file_trans.bin
echo.
echo Original Folder: %orig%
echo.
move /y "%~n1_diesel_file_4096k.bin" "decipha"
move /y "%~n1_diesel_file_trans.bin" "decipha"
echo REMEMBER TO CHANGE FILE NAME TO trans.bin if you would like to recompile with this transmission tune.
echo.
pause


:CLEANUP
rem // put pause here if need to check files for debugging
@if exist "0.bin" del 0.bin
@if exist "1.bin" del 1.bin
@if exist "2.bin" del 2.bin
@if exist "9.bin" del 9.bin
@if exist "temp.bin" del temp.bin
echo.
echo Operations Completed Successfully.
goto END

:ERROR
echo.
echo ERROR! No File Selected.
echo.
pause
goto END

:DUPLICATE
echo.
echo !!! Duplicate temporary files already exist !!!


:MISSING
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
pause

:END
echo.
echo End of Execution.
echo.
exit