@echo off
rem // decipha 2020-11-24
echo.
echo Current Folder: 
echo %cd%
echo.
@if exist "%1" goto CONTINUED
@if not exist "%1" goto ERROR
set orig=%cd%

:CONTINUED
echo.
echo // Specified path has been found! //
echo.
@if not "%cd%" == "D:\TUNING\xvi32" goto REMOTE_LOCATION


rem // need to copy source to xvi32 folder
@if exist "D:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 D:\TUNING\xvi32\temp.bin
d:
cd D:\TUNING\xvi32
goto CONTINUED


:REMOTE_LOCATION
echo REMOTE LOCATION
rem // need to copy source to xvi32 folder
@if exist "C:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 C:\TUNING\xvi32\temp.bin
C:
cd C:\TUNING\xvi32


:CONTINUED
rem // verify if free and clear to use temp file names
@if exist "0.bin" goto DUPLICATE
@if exist "1.bin" goto DUPLICATE
@if exist "8.bin" goto DUPLICATE
@if exist "9.bin" goto DUPLICATE
rem // verify operations files are not missing
rem // only list which files are missing
@if not exist "decipha\MMC\200.bin" echo !!! Missing null 0x200 file for recompiling !!!
@if not exist "decipha\MMC\20000.bin" echo !!! Missing null 0x20,000 file for recompiling !!!
@if not exist "decipha\MMC\A8200.bin" echo !!! Missing null 0xA8,200 file for recompiling !!!
@if not exist "decipha\MMC\1E0000.bin" echo !!! Missing null 0x1E0,000 file for recompiling !!!
@if not exist "decipha\MMC\Split_Bank_A.xsc" echo !!! Missing critical operation file: Split_Bank_A.xsc !!!
@if not exist "decipha\MMC\Split_Bank_B.xsc" echo !!! Missing critical operation file: Split_Bank_B.xsc !!!
@if not exist "decipha\MMC\Split_Bank_C.xsc" echo !!! Missing critical operation file: Split_Bank_C.xsc !!!
@if not exist "decipha\MMC\Split_Bank_D.xsc" echo !!! Missing critical operation file: Split_Bank_D.xsc !!!
@if not exist "decipha\MMC\del_20k_at_0.xsc" echo !!! Missing critical operation file: del_20k_at_0.xsc !!!
@if not exist "decipha\MMC\del_1e0400_at_3dfc00.xsc" echo !!! Missing critical operation file: del_1e0400_at_3dfc00.xsc !!!
rem // jump cuz files are missing now
@if not exist "decipha\MMC\200.bin" goto MISSING
@if not exist "decipha\MMC\20000.bin" goto MISSING
@if not exist "decipha\MMC\A8200.bin" goto MISSING
@if not exist "decipha\MMC\1E0000.bin" goto MISSING
@if not exist "decipha\MMC\Split_Bank_A.xsc" goto MISSING
@if not exist "decipha\MMC\Split_Bank_B.xsc" goto MISSING
@if not exist "decipha\MMC\Split_Bank_C.xsc" goto MISSING
@if not exist "decipha\MMC\Split_Bank_D.xsc" goto MISSING
@if not exist "decipha\MMC\del_20k_at_0.xsc" goto MISSING
@if not exist "decipha\MMC\del_1e0400_at_3dfc00.xsc" goto MISSING

echo.
echo.
echo Input File: %~n1
echo.
echo Convert 3967kb 15-17 PCM standard file [0-1] to 4096kb [1-0] file for MMC Flasher / PCMflash.
echo.

rem // first make duplicate files to be able to split each bank
copy /b /v /n /y "temp.bin" "0.bin"
copy /b /v /n /y "temp.bin" "1.bin"
copy /b /v /n /y "temp.bin" "8.bin"
copy /b /v /n /y "temp.bin" "9.bin"


rem // Split Banks
xvi32.exe 0.bin /S=decipha\MMC\Split_Bank_A.xsc
xvi32.exe 1.bin /S=decipha\MMC\Split_Bank_B.xsc
xvi32.exe 8.bin /S=decipha\MMC\Split_Bank_C.xsc
xvi32.exe 9.bin /S=decipha\MMC\Split_Bank_D.xsc


rem // Recompile to 4mb 
copy /b /v /n /y "decipha\MMC\20000.bin" + "0.bin" + "1.bin" + "8.bin" + "9.bin" + "decipha\MMC\A8200.bin" + "decipha\MMC\200.bin" "%~n1_4m.bin"
echo.
echo New File Name: %~n1_4m.bin
echo.
echo Original Folder: %orig%
echo.
move /y "%~n1_4m.bin" "decipha"


:CLEANUP
rem // put pause here if need to check files for debugging
@if exist "0.bin" del 0.bin
@if exist "1.bin" del 1.bin
@if exist "8.bin" del 8.bin
@if exist "9.bin" del 9.bin
@if exist "temp.bin" del temp.bin
echo.
echo Operations Completed Successfully.
goto END

:ERROR
echo.
echo ERROR! No File Selected.
echo.
pause
goto END

:DUPLICATE
echo.
echo !!! Duplicate temporary files already exist !!!


:MISSING
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
pause

:END
echo.
echo End of Execution.
echo.
exit