@echo off
rem // decipha 2020-11-24
echo.
echo Current Folder: 
echo %cd%
echo.
@if exist "%1" goto CONTINUER
@if not exist "%1" goto ERROR
set orig=%cd%

:CONTINUER
echo.
echo // Specified path has been found! //
echo.
@if not "%cd%" == "D:\TUNING\xvi32" goto REMOTE_LOCATION


rem // need to copy source to xvi32 folder
@if exist "D:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 D:\TUNING\xvi32\temp.bin
d:
cd D:\TUNING\xvi32
goto CONTINUED


:REMOTE_LOCATION
echo REMOTE LOCATION
rem // need to copy source to xvi32 folder
@if exist "C:\TUNING\xvi32\temp.bin" goto DUPLICATE
copy %1 C:\TUNING\xvi32\temp.bin
C:
cd C:\TUNING\xvi32


:CONTINUED
rem // verify if free and clear to use temp file names
@if exist "0.bin" goto DUPLICATE
@if exist "1.bin" goto DUPLICATE
@if exist "8.bin" goto DUPLICATE
@if exist "9.bin" goto DUPLICATE
rem // verify operations files are not missing
rem // only list which files are missing
@if not exist "decipha\MMC\13FE00.bin" echo !!! Missing null 0x13F,E00 file for recompiling !!!
@if not exist "decipha\MMC\del_20k_at_0.xsc" echo !!! Missing critical operation file: del_20k_at_0.xsc !!!
@if not exist "decipha\MMC\del_end.xsc" echo !!! Missing critical operation file: del_end.xsc !!!
@if not exist "decipha\MMC\Split_A.xsc" echo !!! Missing critical operation file: Split_A.xsc !!!
@if not exist "decipha\MMC\Split_B.xsc" echo !!! Missing critical operation file: Split_B.xsc !!!
rem // jump cuz files are missing now
@if not exist "decipha\MMC\13FE00.bin" goto MISSING
@if not exist "decipha\MMC\Split_A.xsc" goto MISSING
@if not exist "decipha\MMC\Split_B.xsc" goto MISSING
@if not exist "decipha\MMC\del_20k_at_0.xsc" goto MISSING
@if not exist "decipha\MMC\del_end.xsc" goto MISSING

echo.
echo.
echo Input File: %~n1
echo.
echo Converts 4096kb PCMflash / MMC Flasher file to 3967kb 15-17 PCM standard file.
echo.

rem // begin
xvi32.exe temp.bin /S=decipha\MMC\del_20k_at_0.xsc
copy temp.bin 1.bin
rem // Split Banks

xvi32.exe temp.bin /S=decipha\MMC\Split_A.xsc
xvi32.exe 1.bin /S=decipha\MMC\Split_B.xsc

//recompile temp
copy /b /v /n /y "temp.bin" + "decipha\MMC\13FE00.bin" + "1.bin"  "8.bin"

// clip off end
xvi32.exe 8.bin /S=decipha\MMC\del_end.xsc


rem // Recompile to 3967kb 
ren "8.bin" "%~n1_std.bin"
echo.
echo New File Name: %~n1_std.bin
echo.
echo Original Folder: %orig%
echo.
move /y "%~n1_std.bin" "decipha"


:CLEANUP
rem // put pause here if need to check files for debugging
@if exist "0.bin" del 0.bin
@if exist "1.bin" del 1.bin
@if exist "8.bin" del 8.bin
@if exist "9.bin" del 9.bin
@if exist "temp.bin" del temp.bin
echo.
echo Operations Completed Successfully.
goto END

:ERROR
echo.
echo ERROR! No File Selected.
echo.
pause
goto END

:DUPLICATE
echo.
echo !!! Duplicate temporary files already exist !!!


:MISSING
echo.
echo FATAL ERROR! OPERATION TERMINATED - CANNOT PERFORM OPERATION REQUESTED.
echo.
pause

:END
echo.
echo End of Execution.
echo.
exit